import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)
import java.util.Random;

public class Logbuch extends Item
{
    private String eintrag = this.erzeugeLogbuchEintrag();
    private int seitenanzahl = Greenfoot.getRandomNumber(124) + 32;
    private String letztesDatum = erzeugeZufaelligesDatum();
    private boolean istGeoeffnet = (Greenfoot.getRandomNumber(2) == 1);

    public String erzeugeLogbuchEintrag() {
        Random zufall = new Random();

        String[] subjektListe = {
                "Seltsame Lichter", "Antriebssysteme", "Sondenbilder", "Kommunikation", 
                "Energiesignaturen", "Mannschaft", "Unbekannte Struktur", "Langstreckenscanner",
                "Navigationssystem", "Außenhülle", "Triton-Mission", "Orbitalsensoren"
            };

        String[] verbListe = {
                "entdeckt", "zeigen Abweichungen", "empfangen", "unterbrochen", 
                "registriert", "meldet Probleme", "gesichtet", "erfassen Bewegungen", 
                "reagieren ungewöhnlich", "weisen Schäden auf", "wird vorbereitet", "liefern Daten"
            };

        String[] kommentarListe = {
                "Analyse läuft", "Wartung eingeleitet", "Weitere Beobachtung notwendig",
                "Ursache unklar", "Medizinische Überprüfung angeordnet", 
                "Erkundungsmission geplant", "Alarmbereitschaft erhöht", 
                "Technikerteam informiert", "Systemneustart empfohlen", 
                "Manöver zur Kurskorrektur eingeleitet"
            };

        // Datum über eigene Methode holen
        String datum = erzeugeZufaelligesDatum();

        // Textbausteine zufällig auswählen
        String subjekt = subjektListe[zufall.nextInt(subjektListe.length)];
        String verb = verbListe[zufall.nextInt(verbListe.length)];
        String kommentar = kommentarListe[zufall.nextInt(kommentarListe.length)];

        // Logbucheintrag zusammensetzen
        return datum + " - " + subjekt + " " + verb + ". " + kommentar + ".";
    }

    private String erzeugeZufaelligesDatum() {
        int jahr = 2034;
        int monat = 5 + Greenfoot.getRandomNumber(4); // 5 = Mai, 6, 7, 8 = August
        int tag = 1 + Greenfoot.getRandomNumber(28);  // 1 bis 28 (sicher für alle Monate)

        return String.format("%02d.%02d.%d", tag, monat, jahr);
    }
}
