import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot und MouseInfo)

public class Peetie extends Robot
{
    private int speed = 5;

    public void act() 
    {
        this.mausFolgen();
        this.checkItemTouch();
    }

    public void checkItemTouch() {
        if (Greenfoot.isKeyDown("space")) {
            Item itemDasIchBeruehre = (Item) this.getOneIntersectingObject(Item.class);
            if (itemDasIchBeruehre != null) {

                // =========================================================
                // === LOGBUCH wird berührt (Leertaste wurde gedrückt)     ===
                // =========================================================
                if (itemDasIchBeruehre instanceof Logbuch) {
                    Logbuch l = (Logbuch) itemDasIchBeruehre;

                    // Aufgabe: Logbuch benutzen
                    //
                    // Wenn das Logbuch noch nicht geöffnet ist,
                    // öffnen Sie das Logbuch, indem Sie den Setter benutzen
                    // Geben Sie »Logbuch wurde geöffnet!« aus
                    //
                    // Wenn das Logbuch bereits geöffnet ist,
                    // geben Sie »Logbuch war schon geöffnet.« aus
                    //
                    // Geben Sie den Text des aktuellen Logbucheintrags aus
                    //
                    // Geben Sie die Seitenanzahl des Logbuchs aus
                    //
                    // Geben Sie das Datum des letzten Eintrags aus
                }

                // =========================================================
                // === HEBEL wird berührt (Leertaste wurde gedrückt)       ===
                // =========================================================
                if (itemDasIchBeruehre instanceof Hebel) {
                    Hebel h = (Hebel) itemDasIchBeruehre;

                    // Aufgabe: Hebel umlegen
                    //
                    // Wenn der Hebel nicht gesperrt ist und der Hebel nicht umgelegt ist,
                    // legen Sie den Hebel um, indem Sie den Setter benutzen
                    // Geben Sie »Hebel erfolgreich umgelegt!« aus
                    //
                    // Wenn der Hebel gesperrt ist, geben Sie »Hebel ist gesperrt und kann nicht benutzt werden.« aus
                    //
                    // Bonus: Geben Sie zusätzlich aus, ob der Hebel jetzt offen oder gesperrt ist
                }

                // =========================================================
                // === HÖHENMESSER wird berührt (Leertaste wurde gedrückt)  ===
                // =========================================================
                if (itemDasIchBeruehre instanceof Hoehenmesser) {
                    Hoehenmesser hm = (Hoehenmesser) itemDasIchBeruehre;

                    // Aufgabe: Höhenmesser kalibrieren
                    //
                    // Wenn der Höhenmesser noch nicht kalibriert ist,
                    // setzen Sie den Kalibrierungswert auf die aktuelle Höhe, indem Sie den Setter benutzen
                    // Setzen Sie außerdem istKalibriert auf true
                    // Geben Sie »Höhenmesser wurde kalibriert!« aus
                    //
                    // Wenn der Höhenmesser bereits kalibriert ist,
                    // geben Sie »Höhenmesser war schon kalibriert.« aus
                    //
                    // Geben Sie die aktuelle Höhe aus
                    //
                    // Geben Sie den Kalibrierungswert aus
                }

                // =========================================================
                // === MÜLLEIMER wird berührt (Leertaste wurde gedrückt)    ===
                // =========================================================
                if (itemDasIchBeruehre instanceof Muelleimer) {
                    Muelleimer m = (Muelleimer) itemDasIchBeruehre;

                    // Aufgabe: Mülleimer prüfen und leeren
                    //
                    // ** Wenn Sie das mit den Gettern und Settern jetzt verstanden haben, können Sie
                    // sich die Getter und Setter mit einer KI generieren lassen. Gehen Sie dazu zu
                    // duck.ai, geben Sie die Klassenvariablen ein, sagen Sie, dass Sie die Getter und
                    // Setter in Java benötigen, und fertig :-)
                    //
                    //
                    // Wenn der Mülleimer defekt ist,
                    // geben Sie »Mülleimer ist defekt und kann nicht benutzt werden.« aus
                    //
                    // Wenn der Mülleimer nicht defekt ist und der Füllstand 100 Prozent erreicht oder überschritten hat,
                    // setzen Sie istVoll auf true, indem Sie den Setter benutzen
                    // Geben Sie »Mülleimer ist voll!« aus
                    //
                    // Wenn der Mülleimer voll ist,
                    // rufen Sie die Methode leeren() auf
                    // Geben Sie »Mülleimer wurde geleert.« aus
                    //
                    // Prüfen Sie danach, ob der Mülleimer wirklich leer ist (Füllstand 0 und istVoll false)
                    // Geben Sie »Mülleimer ist jetzt leer.« aus, wenn alles stimmt
                    //
                    // Geben Sie den aktuellen Füllstand des Mülleimers aus
                }
            }
        }
    }

    public void textausgeben(String pText) {
        this.getWorld().showText(pText, 640, 300);
        Greenfoot.delay(100); // Warten, damit der Text sichtbar bleibt
        this.getWorld().showText("", 640, 300); // Text wieder löschen
    }

    public void mausFolgen() {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null) {
            int dx = mouse.getX() - getX();
            int dy = mouse.getY() - getY();

            double distance = Math.hypot(dx, dy);
            double speed = distance * 0.1; // Geschwindigkeit proportional zur Entfernung

            if (speed > 10) {
                speed = 10; // Maximalgeschwindigkeit
            }

            if (distance > speed) { 
                setLocation(getX() + (int)(speed * dx / distance), getY() + (int)(speed * dy / distance));
            } else {
                setLocation(mouse.getX(), mouse.getY());
            }
        }
    }
}
